// PlainC.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "CSharpLib.h"

int _tmain(int argc, _TCHAR* argv[])
{
	long longVal;
	BSTR stringValReturned = SysAllocString(L"");
	BSTR customValReturned = SysAllocString(L"");

	HRESULT hr = S_OK;
	INetClassComVisible* dotNetClass = NULL;
	INetProviderComVisible* dotNetProvider = NULL;

	hr = CoInitialize(NULL);

	//---Example 1 Simple------
	hr = CoCreateInstance(&CLSID_NetClass, NULL, CLSCTX_INPROC_SERVER, &IID_INetClassComVisible, (void**) &dotNetClass);
	if (hr == S_OK)
		hr = dotNetClass->lpVtbl->get_StringValue(dotNetClass,&stringValReturned);

	//---Example 2 Complex-----

	hr = CoCreateInstance(&CLSID_NetProvider, NULL, CLSCTX_INPROC_SERVER, &IID_INetProviderComVisible, (void**) &dotNetProvider);
	if (hr == S_OK)
	{
		hr = dotNetProvider->lpVtbl->CreateInstance(dotNetProvider, &dotNetClass);
		if (hr == S_OK)
		{
			hr = dotNetClass->lpVtbl->get_IntegerValue(dotNetClass,&longVal);
			hr = dotNetClass->lpVtbl->Add(dotNetClass,8,3,&longVal);
			hr = dotNetClass->lpVtbl->get_CreationTime(dotNetClass,&customValReturned);
		}
	}
	//Free the resources
	SysFreeString(stringValReturned);
	SysFreeString(customValReturned);

	dotNetProvider->lpVtbl->Release(dotNetProvider);
	dotNetClass->lpVtbl->Release(dotNetClass);

	CoUninitialize();

	return 0;
}

